/*
 * This file contains the driver for the wrpHash package
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "wrphash.h"

void do_menu(void);
void do_put(wrpHashTable *ht);
void do_get(wrpHashTable *ht);

int main()
{
	char buf[BUFSIZ];
   int opt, running=1;
   wrpHashTable *ht;

   /* you can let the hash table size default by passing zero */
   printf("Enter size of Hash table (%d): ", WRPHASH_MAX);
   gets(buf);
   opt = atoi(buf);
   ht = wrpHashCreate(opt);	/* create hash table */

   while (running)
   { /* loop getting instructions from user */
   	do_menu();
      printf("Enter option: ");
      gets(buf);
      opt = atoi(buf);

      switch(opt)
      {
      	case 1: do_put(ht); break;
         case 2: do_get(ht); break;
         case 9:
         	printf("Are you sure? (y or n): ");
            gets(buf);
            if (*buf == 'y') running = 0;
            break;
      	default:
         	printf("Invalid option (%s)\n", buf);
      }
   }

   /* all done - clean up after ourselves */
   wrpHashTableFree(ht, free);

   printf("Driver terminating.\n");
   return 0;
}

void do_menu(void)
{
	printf("\nOptions are:\n");
   printf("1. Put Entry into Hash Table\n");
   printf("2. Get Entry from Hash Table\n");
   printf("\n9. Quit\n");
}

void do_put(wrpHashTable *ht)
{
	char key[BUFSIZ], data[BUFSIZ];

   printf("Enter key to add: ");
   gets(key);
   printf("Enter data string for key: ");
   gets(data);

   wrpHashPut(ht, key, strdup(data));
}

void do_get(wrpHashTable *ht)
{
	char key[BUFSIZ], *data;

   printf("Enter key to find: ");
   gets(key);
   data = (char *)wrpHashGet(ht, key);
   printf("Data is >>%s<<\n", data);
}

