/*
 *				**** WRP Hash ****
 *
 * This is the header file for the wrp Hash Table
 *
 * (c) 2001 Bill Pringle, all rights reserved
 * Permission granted to use this and related files
 * for non-commercial purposes
 */

#ifndef WRP_HASH
#define WRP_HASH

#include "prodlist.h"
#include "linklist.h"

#define WRPHASH_MAX 1000

typedef struct wrphash {
	int maxent;			/* max. size of hash table */
   ProdPtrList *list;
} wrpHashTable;

wrpHashTable *wrpHashCreate(int maxent);
void wrpHashTableFree(wrpHashTable *ht, void (freefcn(void *data)));
void wrpHashPut(wrpHashTable *ht, char *key, void *dat);
void *wrpHashGet(wrpHashTable *ht, char *key);

#endif
